$(() => {
const gauge = $('#gauge').dxCircularGauge({
scale: {
startValue: 10,
endValue: 40,
tickInterval: 5,
label: {
customizeText(arg) {
return `${arg.valueText} °C`;
},
},
},
rangeContainer: {
ranges: [
{ startValue: 10, endValue: 20, color: '#0077BE' },
{ startValue: 20, endValue: 30, color: '#E6E200' },
{ startValue: 30, endValue: 40, color: '#77DD77' },
],
},
tooltip: { enabled: true },
title: {
text: 'Temperature in the Greenhouse',
font: { size: 28 },
},
value: dataSource[0].mean,
subvalues: [dataSource[0].min, dataSource[0].max],
}).dxCircularGauge('instance');
$('#seasons').dxSelectBox({
width: 150,
dataSource,
displayExpr: 'name',
value: dataSource[0],
onSelectionChanged(e) {
gauge.option('value', e.selectedItem.mean);
gauge.option('subvalues', [e.selectedItem.min, e.selectedItem.max]);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.3/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gauge-demo">
<div id="gauge"></div>
<div id="seasons"></div>
</div>
</div>
</body>
</html>
#gauge-demo {
height: 440px;
width: 100%;
}
#gauge {
width: 80%;
height: 100%;
float: left;
}
#seasons {
width: 20%;
float: left;
text-align: left;
margin-top: 20px;
}
const dataSource = [{
name: 'Summer',
mean: 35,
min: 28,
max: 38,
}, {
name: 'Autumn',
mean: 24,
min: 20,
max: 32,
}, {
name: 'Winter',
mean: 18,
min: 16,
max: 23,
}, {
name: 'Spring',
mean: 27,
min: 18,
max: 31,
}];

import React from 'react';
import {
CircularGauge, Scale, Label, RangeContainer, Range, Tooltip, Title, Font,
} from 'devextreme-react/circular-gauge';
import { SelectBox } from 'devextreme-react/select-box';
import { dataSource } from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
value: dataSource[0].mean,
subvalues: [dataSource[0].min, dataSource[0].max],
};
this.onSelectionChanged = ({ selectedItem }) => {
this.setState({
value: selectedItem.mean,
subvalues: [selectedItem.min, selectedItem.max],
});
};
}
render() {
return (
<div id="gauge-demo">
<CircularGauge
id="gauge"
value={this.state.value}
subvalues={this.state.subvalues}
>
<Scale startValue={10} endValue={40} tickInterval={5}>
<Label customizeText={this.customizeText} />
</Scale>
<RangeContainer>
<Range startValue={10} endValue={20} color="#0077BE" />
<Range startValue={20} endValue={30} color="#E6E200" />
<Range startValue={30} endValue={40} color="#77DD77" />
</RangeContainer>
<Tooltip enabled={true} />
<Title text="Temperature in the Greenhouse">
<Font size={28} />
</Title>
</CircularGauge>
<SelectBox
id="seasons"
width={150}
dataSource={dataSource}
defaultValue={dataSource[0]}
displayExpr="name"
onSelectionChanged={this.onSelectionChanged}
/>
</div>
);
}
customizeText({ valueText }) {
return `${valueText} °C`;
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gauge-demo {
height: 440px;
width: 100%;
}
#gauge {
width: 80%;
height: 100%;
float: left;
}
#seasons {
width: 20%;
float: left;
text-align: left;
margin-top: 20px;
}
export const dataSource = [{
name: 'Summer',
mean: 35,
min: 28,
max: 38,
}, {
name: 'Autumn',
mean: 24,
min: 20,
max: 32,
}, {
name: 'Winter',
mean: 18,
min: 16,
max: 23,
}, {
name: 'Spring',
mean: 27,
min: 18,
max: 31,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme-react': 'npm:devextreme-react@21.2.7',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<div id="gauge-demo">
<DxCircularGauge
id="gauge"
:value="value.mean"
:subvalues="[value.min, value.max]"
>
<DxScale
:start-value="10"
:end-value="40"
:tick-interval="5"
>
<DxLabel
:customize-text="customizeText"
/>
</DxScale>
<DxRangeContainer>
<DxRange
:start-value="10"
:end-value="20"
color="#0077BE"
/>
<DxRange
:start-value="20"
:end-value="30"
color="#E6E200"
/>
<DxRange
:start-value="30"
:end-value="40"
color="#77DD77"
/>
</DxRangeContainer>
<DxTooltip
:enabled="true"
/>
<DxTitle
text="Temperature in the Greenhouse"
>
<DxFont
:size="28"
/>
</DxTitle>
</DxCircularGauge>
<DxSelectBox
id="seasons"
:width="150"
:data-source="dataSource"
v-model:value="value"
display-expr="name"
/>
</div>
</div>
</template>
<script>
import {
DxCircularGauge, DxScale, DxLabel, DxRangeContainer, DxRange, DxTooltip, DxTitle, DxFont,
} from 'devextreme-vue/circular-gauge';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { dataSource } from './data.js';
export default {
components: {
DxCircularGauge,
DxScale,
DxLabel,
DxRangeContainer,
DxRange,
DxTooltip,
DxTitle,
DxFont,
DxSelectBox,
},
data() {
return {
dataSource,
value: dataSource[0],
};
},
methods: {
customizeText({ valueText }) {
return `${valueText} °C`;
},
onSelectionChanged({ selectedItem }) {
this.value = selectedItem.mean;
this.subvalues = [selectedItem.min, selectedItem.max];
},
},
};
</script>
<style scoped>
#gauge-demo {
height: 440px;
width: 100%;
}
#gauge {
width: 80%;
height: 100%;
float: left;
}
#seasons {
width: 20%;
float: left;
text-align: left;
margin-top: 20px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const dataSource = [{
name: 'Summer',
mean: 35,
min: 28,
max: 38,
}, {
name: 'Autumn',
mean: 24,
min: 20,
max: 32,
}, {
name: 'Winter',
mean: 18,
min: 16,
max: 23,
}, {
name: 'Spring',
mean: 27,
min: 18,
max: 31,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.41/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<div id="gauge-demo">
<dx-circular-gauge
id="gauge"
[value]="value.mean"
[subvalues]="[value.min, value.max]"
>
<dxo-range-container>
<dxi-range [startValue]="10" [endValue]="20" color="#0077BE"></dxi-range>
<dxi-range [startValue]="20" [endValue]="30" color="#E6E200"></dxi-range>
<dxi-range [startValue]="30" [endValue]="40" color="#77DD77"></dxi-range>
</dxo-range-container>
<dxo-scale [startValue]="10" [endValue]="40" [tickInterval]="5">
<dxo-label [customizeText]="customizeText"></dxo-label>
</dxo-scale>
<dxo-tooltip [enabled]="true"></dxo-tooltip>
<dxo-title text="Temperature in the Greenhouse">
<dxo-font [size]="28"></dxo-font>
</dxo-title>
</dx-circular-gauge>
<dx-select-box
#seasons
id="seasons"
[dataSource]="dataSource"
[width]="150"
displayExpr="name"
[(value)]="value"
>
</dx-select-box>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxCircularGaugeModule, DxSelectBoxModule } from 'devextreme-angular';
import { Data, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
dataSource: Data[];
value: Data;
constructor(service: Service) {
this.dataSource = service.getData();
this.value = this.dataSource[0];
}
customizeText(arg) {
return `${arg.valueText} °C`;
}
}
@NgModule({
imports: [
BrowserModule,
DxCircularGaugeModule,
DxSelectBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gauge-demo {
height: 440px;
width: 100%;
}
::ng-deep #gauge {
width: 80%;
height: 100%;
float: left;
}
::ng-deep #seasons {
width: 20%;
float: left;
text-align: left;
margin-top: 20px;
}
import {
Injectable,
} from '@angular/core';
export class Data {
name: string;
mean: number;
min: number;
max: number;
}
const dataSource: Data[] = [{
name: 'Summer',
mean: 35,
min: 28,
max: 38,
}, {
name: 'Autumn',
mean: 24,
min: 20,
max: 32,
}, {
name: 'Winter',
mean: 18,
min: 16,
max: 23,
}, {
name: 'Spring',
mean: 27,
min: 18,
max: 31,
}];
@Injectable()
export class Service {
getData(): Data[] {
return dataSource;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.3.5/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@21.2.7/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13',
'devextreme-angular': 'npm:devextreme-angular@21.2.7',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@6.4.0/package.json',
'npm:rxjs@6.4.0/operators/package.json',
'npm:devextreme-angular@21.2.7/*/package.json',
'npm:devextreme-angular@21.2.7/ui/*/package.json',
'npm:devextreme-angular@21.2.7/package.json',
'npm:devexpress-diagram@2.1.47/package.json',
'npm:devexpress-gantt@4.0.13/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.11.4/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>